<!-- zwPopupPick 底部弹出选择 -->
<template>
  <div>
    <van-popup v-model="popup_show" position="bottom">
      <van-picker v-if="popup_show" :title="title" :default-index="defaultIndex" show-toolbar :value-key="lable" :columns="columns" @cancel="cancel" @confirm="onConfirm" />
    </van-popup>
  </div>
</template>

<script>
/**
 * @confirm 选中
 */
export default {
  name: 'zwPopupPick',
  props: {
    show: {
      required: true,
      type: Boolean,
      default: () => {
        return false
      }
    },
    //列表数据
    columns: {
      type: Array,
      required: true,
      default: () => { return [] }
    },

    // 展示的 字段名
    'lable': {
      type: String,
      default: 'name'
    },

    // 所选的id 
    'value': {
      type: String | Number,
      default: ''
    },

    //所选值的key
    'valueKey': {
      type: String,
      default: 'id'
    },

    // 标题名
    title: {
      type: String,
      default: ''
    }

  },
  data() {
    return {
      popup_show: this.show,
    }
  },
  computed: {
    defaultIndex() {
      let valueKey = this.valueKey
      if (!valueKey) {
        return 0
      }
      let index = this.columns.findIndex(i => i[valueKey] == this.value)
      return index != -1 ? index : 0
    }

  },
  methods: {
    //初始化方法
    init() {

    },

    cancel() {
      this.popup_show = false
    },

    onConfirm(v) {
      this.$emit('confirm', v)
      this.$emit('input',v[this.valueKey])
      this.popup_show = false

    },

  },

  watch: {
    show(v) {
      this.popup_show = v
    },

    popup_show(v) {
      this.$emit('update:show', v)
    }

  }
}

</script>
<style lang='scss' scoped>
</style>